#!/bin/bash

set -e

. /usr/share/acpi-support/power-funcs
. /usr/share/acpi-support/policy-funcs

VGAHOTPLUG_DPMS=xrandr

gethotplug() {
    d=/tmp/.X11-unix
    for x in $d/X*; do
        displaynum=${x#$d/X}
        getXuser;
	echo "XAUTHORITY = $XAUTHORITY."
        if [ x$XAUTHORITY != x ]; then
            export DISPLAY=":$displaynum"
            export XAUTHORITY=$XAUTHORITY
            case "$VGAHOTPLUG_DPMS" in
                xset)
                        su "$XUSER" -s /bin/sh -c "xset dpms force on"
                        ;;
                xrandr)
                        su "$XUSER" -s /bin/sh -c "xrandr"
                        ;;
                vbetool)
                        /usr/sbin/vbetool dpms on
                        ;;
            esac
        else
            if [ -x$DISPLAY_DPMS_NO_USER = xtrue ]; then
                [ -x /usr/sbin/vbetool ] && /usr/sbin/vbetool dpms on
            fi
        fi
    done
    if [ -f /sys/class/drm/card*-VGA-*/status ]; then
       cp -f /sys/class/drm/card*-VGA-*/status /tmp/oldvga_status
    fi
}

if [ ! -f /tmp/oldvga_status ]; then
   echo "first hotplug the VGA display..."
   gethotplug;
else
   oldvgastatus=`cat /tmp/oldvga_status`
   newvgastatus=`cat /sys/class/drm/card*-VGA-*/status`
   echo "oldvgastatus = $oldvgastatus, newvgastatus = $newvgastatus."
   if [[ $newvgastatus != $oldvgastatus  ]]; then
     #logger -t /etc/udev/rules.d/hotplugvga.sh "VGA disconnected line 8"
     echo "No first plugin, adjust the VGA display..."
     gethotplug;
   fi
fi

exit 0


